from tkinter import *
import random

def hex_to_rgb(value):
    """Return (red, green, blue) for the color given as #rrggbb."""
    value = value.lstrip('#')
    lv = len(value)
    return tuple(int(value[i:i + lv // 3], 16) for i in range(0, lv, lv // 3))

def rgb_to_hex(red, green, blue):
    """Return color as #rrggbb for the given color values."""
    return '#%02x%02x%02x' % (red, green, blue)

"""
hex_to_rgb("#ffffff")           #==> (255, 255, 255)
hex_to_rgb("#ffffffffffff")     #==> (65535, 65535, 65535)
rgb_to_hex(255, 255, 255)       #==> '#ffffff'
rgb_to_hex(65535, 65535, 65535) #==> '#ffffffffffff'
"""

def draw_tree(tree_list, pos, side_len):
    if isinstance(tree_list[0], int):
        col=rgb_to_hex(tree_list[0], tree_list[0], tree_list[0])
        canvas.create_rectangle(pos[0], pos[1], pos[0]+side_len, pos[1]+side_len, outline=col, fill=col)
    else:
        draw_tree(tree_list[0], pos, side_len / 2)
    if isinstance(tree_list[1], int):
        col=rgb_to_hex(tree_list[1], tree_list[1], tree_list[1])
        canvas.create_rectangle(pos[0]+side_len, pos[1], pos[0]+2*side_len, pos[1]+side_len, outline=col, fill=col)
    else:
        draw_tree(tree_list[1], [pos[0]+side_len,pos[1]], side_len / 2)
    if isinstance(tree_list[2], int):
        col=rgb_to_hex(tree_list[2], tree_list[2], tree_list[2])
        canvas.create_rectangle(pos[0]+side_len, pos[1]+side_len, pos[0]+2*side_len, pos[1]+2*side_len, outline=col, fill=col)
    else:
        draw_tree(tree_list[2], [pos[0]+side_len,pos[1]+side_len], side_len / 2)
    if isinstance(tree_list[3], int):
        col=rgb_to_hex(tree_list[3], tree_list[3], tree_list[3])
        canvas.create_rectangle(pos[0], pos[1]+side_len, pos[0]+side_len, pos[1]+2*side_len, outline=col, fill=col)
    else:
        draw_tree(tree_list[3], [pos[0],pos[1]+side_len], side_len / 2)

def close_window(): 
    window.destroy()

def key_pressed(event):
    print("pressed", repr(event.char))

def mouse_button_clicked(event):
    print("clicked at", event.x, event.y)

side_len = 128
start_x = 10
start_y = 10

window = Tk()

canvas = Canvas(window, width=400, height=400)
window.bind_all("<Key>", key_pressed)
canvas.bind("<Button-1>", mouse_button_clicked)
canvas.pack()    
frame = Frame(window)
frame.pack()
button = Button (frame, text = "quit", command = close_window)
button.pack()

#canvas.create_line(0, 0, 200, 100)
#canvas.create_line(0, 100, 200, 0, fill="red", dash=(4, 4))
#canvas.create_rectangle(25, 25, 50, 50, outline="blue", fill="blue")

img_tree = [123,76,45,190]
#img_tree = [[123,76,45,190],35,[78,23,[23,[70,220,[75,12,210,30],115],12,150],56],72]


draw_tree(img_tree, [start_x, start_y], side_len)

window.mainloop()

"""
def traverse_tree(tree_list, num=0): #---------- testing
    for element in tree_list:
        if type(element) is list:
            num = traverse_tree(element, num)
        else:
            print(str(num) + ":", element)
            num += 1
    return num

def rebuild_tree_(tree_list): #---------- testing
    new_tree = []
    for element in tree_list:
        if type(element) is list:
            new_tree.append(rebuild_tree_(element))
        else:
            new_tree.append(element)
    return new_tree

def rebuild_tree(tree_list, node_pos=0): #---------- testing
    new_tree = []
    for element in tree_list:
        if type(element) is list:
            branch, node_pos = rebuild_tree(element, node_pos)
            new_tree.append(branch)
        else:
            new_tree.append(element)
            node_pos += 1
    return new_tree, node_pos
"""

