from tkinter import *

labyrinth_arr = [
"#####################",
"#####################",
"##..........##0....##",
"##.#.##.##########.##",
"##.#.1#.##0.##.....##",
"####.##.###.######.##",
"##...##.##1.....2#.##",
"##.########.######.##",
"##.##....##........##",
"##....##....#2##.####",
"#####################",
"#####################"
]

col_arr = ["#ff0000","#ff00ff","#0000ff"]

def hex_to_rgb(value):
    """Return (red, green, blue) for the color given as #rrggbb."""
    value = value.lstrip('#')
    lv = len(value)
    return tuple(int(value[i:i + lv // 3], 16) for i in range(0, lv, lv // 3))

def rgb_to_hex(red, green, blue):
    """Return color as #rrggbb for the given color values."""
    return '#%02x%02x%02x' % (red, green, blue)

"""
hex_to_rgb("#ffffff")           #==> (255, 255, 255)
hex_to_rgb("#ffffffffffff")     #==> (65535, 65535, 65535)
rgb_to_hex(255, 255, 255)       #==> '#ffffff'
rgb_to_hex(65535, 65535, 65535) #==> '#ffffffffffff'
"""
      
def draw_scene(pos, side_len):
    for y in range(pos_y-2,pos_y+3):
        for x in range(pos_x-2,pos_x+3):
            if (x == pos_x) and (y == pos_y):
                col=rgb_to_hex(250,250,250)
            elif labyrinth_arr[x][y]==".":
                col=rgb_to_hex(125,125,125)
            elif labyrinth_arr[x][y]=="#":
                col=rgb_to_hex(25,25,25)
            else:
                col=col_arr[int(labyrinth_arr[x][y])]
            w.create_rectangle( pos[1]+(y-pos_y)*side_len, pos[0]+(x-pos_x)*side_len, pos[1]+(y+1-pos_y)*side_len, pos[0]+(x+1-pos_x)*side_len, outline=col, fill=col)

def key(event):
    global pos_x
    global pos_y
    if event.char == event.keysym:
        msg = 'Normal Key %r' % event.char
        print(event.char)
    elif len(event.char) == 1:
        msg = 'Punctuation Key %r (%r)' % (event.keysym, event.char)
    else:
        msg = 'Special Key %r' % event.keysym
        if event.keysym == "Up" and labyrinth_arr[pos_x-1][pos_y] != "#":
            if pos_x > 2:
                pos_x -= 1
        if event.keysym == "Down" and labyrinth_arr[pos_x+1][pos_y] != "#":
            if pos_x < 9:
                pos_x += 1
        if event.keysym == "Left" and labyrinth_arr[pos_x][pos_y-1] != "#":
            if pos_y > 2:
                pos_y -= 1
        if event.keysym == "Right" and labyrinth_arr[pos_x][pos_y+1] != "#":
            if pos_y < 18:
                pos_y += 1
    #label1.config(text=msg)
    #print("pos_x:", pos_x, "pos_y:", pos_y)
    draw_scene([75,75],50)

root = Tk()

w = Canvas(root, width=800, height=400)
w.pack()

pos_x=2
pos_y=2


prompt = "      Verwende die Pfeiltasten      "
label1 = Label(root, text=prompt, width=len(prompt), bg="yellow")
label1.pack()

root.bind_all("<Key>", key)
draw_scene([75,75],50)
root.mainloop()


